# -*- coding: utf-8 -*-

"""Main module."""
import random

import discord
from discord.ext import commands

import os
import requests

class Mybot(commands.Cog):
    def __init__(self, bot):
        self.bot = bot

    @commands.command(help='test')
    async def join_channel(self, ctx):
        channel = [x for x in self.bot.get_all_channels() if x.name == "Général"][0]
        await channel.connect()

    @commands.command()
    async def ping(self, message):
        await message.channel.send('pong')

    @commands.command()
    async def kaamelott(self, ctx, *args):
        response = None
        if not args:
            url = 'https://kaamelott.chaudie.re/api/random'
        elif args[0] in 'help':
            response = "!kaamelott [livre] [character]"
            await ctx.send(response)
            return
        else:
            args = list(args)
            if args[0].isdigit():
                livre = int(args[0])
                args.pop(0)
            elif args[-1].isdigit():
                livre = int(args[-1])
                args.pop(-1)
            else:
                livre = None
            if args:
                perso = ' '.join(args)
            if perso and livre:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s/personnage/%s' % (livre,perso)
            elif perso:
                url = 'https://kaamelott.chaudie.re/api/random/personnage/%s' % perso
            else:
                url = 'https://kaamelott.chaudie.re/api/random/livre/%s' % livre
        try:
            citation = requests.get(url).json()['citation']
            response = "%s : %s" % (citation['infos']['personnage'], citation['citation'])
        except:
            response = "Unknow error, try: !kaamelott [livre] [character]"
        await ctx.send(response)

    @commands.command()
    async def kadoc(self, ctx):
        quotes = [
            "Pour savoir s’y a du vent, il faut mettre son doigt dans le cul du coq.",
            "Y'a des méchants ?",
            "À Kabot ! À Kabot !",
            "Tatan, elle fait des flans.",
            "Les pattes de canaaaaaaaaaaaaaaaaaaaaaaaaaaaaard !",
            "Elle est où la poulette ?",
            "Mooordu! Mooordu! Mordu mordu mordu mordu la ligne !!!!",
        ]
        response = random.choice(quotes)
        await ctx.send(response)

    async def on_message(self, message):
        print(message.content)
        if message.author == self.user:
            return
        if message.content.startswith('!') and not message.content.startswith('!on_'):
            try:
                print('self.' + message.content[1:] + '(message)')
                await eval('self.' + message.content[1:] + '(message)')
            except:
                await message.channel.send("%s ? Ouais, c'est pas faux !" %  message.content[1:])
        if message.content == 'pwet':
            await message.channel.send('pong')
        else:
            if self.user in message.mentions and len(message.mentions) < 3:
                path = '/tmp/%s.log' % message.channel
                with open(path, 'r') as f :
                    lines = f.read().splitlines()
                with open(path, 'a') as f :
                    f.write(message.content + '\n')
                response = random.choice(lines).replace(str(self.user.id), str(message.author.id))
                await message.channel.send(response)

            return

def main():
    token = "NjI3MTM3NDY1MDA5ODMxOTQ2.XY4Raw.pw8sAen3bNR5aYsoTChQOudM0L8"
    bot = commands.Bot(command_prefix='!')

    @bot.event
    async def on_message(message):
        print(message.content)
        if message.author == bot.user:
            return
        if message.content == 'pwet':
            await message.channel.send('pong')
        else:
            if bot.user in message.mentions and len(message.mentions) < 3:
                path = '/tmp/%s.log' % message.channel
                with open(path, 'r') as f :
                    lines = f.read().splitlines()
                with open(path, 'a') as f :
                    f.write(message.content + '\n')
                response = random.choice(lines).replace(str(bot.user.id), str(message.author.id))
                await message.channel.send(response)
        await bot.process_commands(message)

    bot.add_cog(Mybot(bot))
    bot.run(token)


if __name__ == "__main__":
    main()

